<template>
	<section class="settings_main">
		<div class="p-3 w-100">
			<div class="settings_content_inr base_block">
				<div class="settings_panel p-3">
					<div class="settings_panel_ttl">
						<div class="txt">{{$store.state.locale.newsType}}</div>
						<button type="button" class="login_main_sign_btn bt" data-toggle="modal"
								data-target="#addModal" @click="modeActionType = 1" v-if="can('settings_newstype', 'Edit')">
							{{$store.state.locale.addInfo}}
						</button>
					</div>

					<div class="settings_panel_cnt">
						<div class="table-responsive settings_content_tb">
							<table class="table table-striped table-hover">
								<thead>
								<tr>
									<th scope="col">Id</th>
									<th scope="col">Uz</th>
									<th scope="col">Ru</th>
									<th scope="col">En</th>
									<th scope="col">Organization</th>
									<th scope="col" class="w-40" v-if="can('settings_newstype', 'Edit')"></th>
								</tr>
								</thead>

								<tbody>
								<tr v-for="item in listItem">
									<td>{{ item.id }}</td>
									<td>{{ item.name_uz }}</td>
									<td>{{ item.name_ru }}</td>
									<td>{{item.name_en}}</td>
									<td>{{getOrganization(item.organizationId)}}</td>
									<td v-if="can('settings_newstype', 'Edit')">
										<div class="btn-group">
											<button type="button" class="icon-btn"
													@click="readInfo(item.id)">
												<i class="mdi mdi-pencil"></i>
											</button>
											<button type="button" class="icon-btn"
													@click="deleteInfo(item.id)">
												<i class="mdi mdi-delete text-danger"></i>
											</button>
										</div>
									</td>
								</tr>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
				 aria-hidden="true">
				<div class="modal-dialog fn_ivr_modal" role="document">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title d-flex justify-content-center w-100" id="exampleModalLabel">Add
								info</h5>
						</div>
						<div class="modal-body">
							<div class="form-group">
								<label class="col-form-label">Uz:</label>
								<input type="text" class="form-control base_input" v-model="addItem.name_uz" required>
							</div>
							<div class="form-group">
								<label class="col-form-label">Ru:</label>
								<input type="text" class="form-control base_input" v-model="addItem.name_ru" required>
							</div>
							<div class="form-group">
								<label class="col-form-label">En:</label>
								<input type="text" class="form-control base_input" v-model="addItem.name_en" required>
							</div>
							<div class="form-group">
								<label class="col-form-label">Organization:</label>
								<select name="" id="" class="custom-select" v-model="addItem.organizationId">
									<option value="">Select organization</option>
									<option v-for="org in organizationList" :value="org.id">{{org.name}}</option>
								</select>
							</div>
							<button type="submit" v-if="!addItem.id" class="fn_btn btn_fn_success mt-3 w-100 m-0" @click="saveInfo">{{$store.state.locale.save}}</button>
							<button type="submit" v-if="addItem.id" class="fn_btn btn_fn_success mt-3 w-100 m-0" @click="updateInfo">{{$store.state.locale.save}}</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</section>
</template>

<script>
	export default {
		name: "index",
		data() {
			return {
				listItem: [],
				organizationList: [],
				addItem: {
					name_uz: "",
					name_ru: "",
					name_en: "",
					organizationId: '',
				}
			}
		},
		created() {
			this.getAll();
		},
		methods: {
			getAll() {
				this.$http.get('/HokimiyatNews/newsTypes').then(res => {
					if (res.data) {
						this.listItem = res.data.newsTypes;
					}
				});
				this.$http.get('/Admin/Organization').then(res => {
					if (res.data) {
						this.organizationList = res.data.data;
					}
				});
			},
			saveInfo() {
				this.$http.post('HokimiyatNews/newsType', this.addItem).then(res => {
					if (res.statusText === "OK") {
						$('#addModal').modal('hide');
						this.getAll();
					}
				})
			},
			deleteInfo(id) {
				if (confirm('You are about to delete the item(s)!\nAre you sure?')) {
					this.$http.delete('HokimiyatNews/newsType/' + id).then(res => {
						if (res.statusText === "OK") {
							this.getAll();
						}
					})
				}
			},
			readInfo(id) {
				this.$http.get('HokimiyatNews/newsType/' + id).then(res => {
					if (res.statusText === "OK") {
						this.addItem = res.data.newsType;
						$('#addModal').modal('show');
					}
				})
			},
			updateInfo() {
				this.$http.patch('HokimiyatNews/newsType/', this.addItem)
					.then(result => {
						if (result.statusText === "OK") {
							$('#addModal').modal('hide');
							this.getAll();
						}
					});
			},
			getOrganization (val) {
				return (this.organizationList.find(item => item.id === val) || {name: ''}).name;
			}
		},
	}
</script>

<style scoped>

</style>